<?php

/**
 * @file
 * Contains \Drupal\iframe\Plugin\Field\FieldWidget\IframeUrlwidthheightWidget.
 */

namespace Drupal\iframe\Plugin\Field\FieldWidget;

use Drupal\Core\Field\WidgetBase;
use Drupal\Core\Field\FieldItemListInterface;
use Drupal\Core\Form\FormStateInterface;

/**
 * @FieldWidget(
 *  id = "iframe_urlwidthheight",
 *  label = @Translation("URL with width and height"),
 *  field_types = {"iframe"}
 * )
 */
class IframeUrlwidthheightWidget extends WidgetBase {

  /**
   * {@inheritdoc}
   */
  public static function defaultSettings() {
    return array(
      'placeholder_url' => '',
      'placeholder_title' => 'Iframe',
    ) + parent::defaultSettings();
  }

  /**
   * {@inheritdoc}
   */
  public function formElement(FieldItemListInterface $items, $delta, array $element, array &$form, FormStateInterface $form_state) {
    /** @var \Drupal\iframe\Plugin\Field\FieldType\IframeItem $item */
    $item = $items[$delta];

    $element['url'] = array(
      '#title' => t('URL'),
      '#type' => 'url',
      '#default_value' => isset($items[$delta]->url) ? $items[$delta]->url : NULL,
    );
    return $element;
  } 

}
